/*
 * 
 * See the file exercise_1.txt for informations. 
 *
*/

#include "hdf5.h"

#define FILE "file.h5"

int main()
{
    hid_t file;         /* Handles */
    hid_t group, group_a, group_b;
    hid_t dc_pl, dataspace_id, dataset_id;
    hid_t memspace_id;
    hsize_t chunk[2], dim[2];
    hsize_t dim_sub[2];
    hsize_t start[2], count[2], stride[2], block[2];
    herr_t      status;

    int i,j;
    int dset_buf[8][10];
    int sub_data[3][4];

/* step 1 */
    file = H5Fcreate (FILE, H5F_ACC_TRUNC, H5P_DEFAULT, H5P_DEFAULT);

    status = H5Fclose (file);


/* step 2 */
    file = H5Fopen (FILE, H5F_ACC_RDWR, H5P_DEFAULT);
    
    group = H5Gcreate (file, "/MyGroup", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT);

    group_a = H5Gcreate (file, "/MyGroup/Group_a", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT);

    group_b = H5Gcreate (group, "Group_b", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT);

    status = H5Gclose (group);
    status = H5Gclose (group_a);
    status = H5Gclose (group_b);
    status = H5Fclose (file);

/* step 3 */
    file = H5Fopen (FILE, H5F_ACC_RDWR, H5P_DEFAULT);
    group = H5Gopen (file, "/MyGroup/Group_a", H5P_DEFAULT);
    
    chunk[0] = chunk [1] = 4;
    dc_pl = H5Pcreate (H5P_DATASET_CREATE); 
    status = H5Pset_chunk (dc_pl, 2, chunk);
    
    dim [0] = 8; 
    dim [1] = 10;
    dataspace_id = H5Screate_simple (2, dim, NULL);  
    
    dataset_id = H5Dcreate(group, "my_dset", H5T_NATIVE_INT, dataspace_id, 
                           H5P_DEFAULT, dc_pl, H5P_DEFAULT);

    status = H5Sclose(dataspace_id);
    status = H5Pclose(dc_pl);
    status = H5Dclose(dataset_id);  
    status = H5Gclose(group);
    status = H5Fclose(file);
      
/* step 4 */
    file = H5Fopen (FILE, H5F_ACC_RDWR, H5P_DEFAULT);
    group = H5Gopen (file, "/MyGroup/Group_a", H5P_DEFAULT);
   
    dataset_id = H5Dopen(group, "my_dset", H5P_DEFAULT);

    for (i=0; i<4; i++){
      for (j=0; j<5; j++){
        dset_buf[i][j]=1;
      }
    }      
    for (i=4; i<8; i++){
      for (j=0; j<5; j++){
        dset_buf[i][j]=2;
      }
    }      
    for (i=0; i<4; i++){
      for (j=5; j<10; j++){
        dset_buf[i][j]=3;
      }
    }      
    for (i=4; i<8; i++){
      for (j=5; j<10; j++){
        dset_buf[i][j]=4;
      }
    }      

    status = H5Dwrite(dataset_id, H5T_NATIVE_INT, H5S_ALL, H5S_ALL, H5P_DEFAULT, dset_buf);

    status = H5Dclose(dataset_id);
    status = H5Gclose(group);
    status = H5Fclose(file);


/* step 5 */

    file = H5Fopen (FILE, H5F_ACC_RDWR, H5P_DEFAULT);
    group = H5Gopen (file, "/MyGroup/Group_a", H5P_DEFAULT);
    dataset_id = H5Dopen (group, "my_dset", H5P_DEFAULT);
    
    /* Creation of the dataspace for the subset of data
       It is a dataspace in memory */
    dim_sub[0] = 3;
    dim_sub[1] = 4; 
    memspace_id = H5Screate_simple (2, dim_sub, NULL); 
    
    /* Selection, in the dataspace of the dataset,
       of the hyperslab where write the new subset of data */
    
    dataspace_id = H5Dget_space (dataset_id);
   
    start[0] = 2; start[1] = 3;
    count[0] = dim_sub[0] ; count[1] = dim_sub[1];
    stride[0] = 1; stride[1] = 1;
    block[0] = 1; block[1] = 1; 
 
    status = H5Sselect_hyperslab (dataspace_id, H5S_SELECT_SET, start, stride, 
            count, block);
   
    /* Initialization of data to be written 
       And writing */

    for (i=0; i<dim_sub[0]; i++){
      for (j=0; j<dim_sub[1]; j++){
        sub_data[i][j]=9;
      }
    }

    status = H5Dwrite (dataset_id, H5T_NATIVE_INT, memspace_id, dataspace_id, H5P_DEFAULT, sub_data);    
    
    status = H5Sclose(memspace_id);
    status = H5Dclose(dataset_id);
    status = H5Gclose(group);
    status = H5Fclose(file);

}
