! 
! See the file exercise_1.txt for informations. 
! 
!
      program file_example
      use hdf5
      implicit none

      character(len=12), parameter :: file_name="file_f.h5"
      integer(hid_t) :: file_id
      integer(hid_t) :: group, group_a, group_b
      integer(hid_t) :: dataspace_id, dataset_id
      integer(hid_t) :: dc_pl
      integer(hid_t) ::  memspace_id
      integer(hsize_t) :: dims(2), maxdims(2)
      integer(hsize_t) :: dims_p(2)
      integer(hsize_t) :: start(2), count(2), stride(2), block(2)
      integer :: hdferr
      integer :: i,j
      integer :: buf(10,8), s_buf(4,3)

! open the fortran interface for hdf5   
      call h5open_f(hdferr);

! step 1
      call h5fcreate_f(file_name, H5F_ACC_TRUNC_F, file_id, hdferr, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

      call h5fclose_f(file_id, hdferr)
         
! step 2
      call h5fopen_f(file_name, H5F_ACC_RDWR_F, file_id, hdferr, & 
                     H5P_DEFAULT_F)
   
      call h5gcreate_f(file_id, "MyGroup", group, hdferr, & 
                       OBJECT_NAMELEN_DEFAULT_F, H5P_DEFAULT_F, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

      call h5gcreate_f(file_id, "/MyGroup/Group_a", group_a, hdferr, & 
                       OBJECT_NAMELEN_DEFAULT_F, H5P_DEFAULT_F, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

      call h5gcreate_f(group, "Group_b", group_b, hdferr, & 
                       OBJECT_NAMELEN_DEFAULT_F, H5P_DEFAULT_F, &
                       H5P_DEFAULT_F, H5P_DEFAULT_F)

      call h5gclose_f(group, hdferr)
      call h5gclose_f(group_a, hdferr)
      call h5gclose_f(group_b, hdferr)
      call h5fclose_f(file_id, hdferr) 

! step 3 
      call h5fopen_f(file_name, H5F_ACC_RDWR_F, file_id, hdferr, & 
                     H5P_DEFAULT_F)
      call h5gopen_f(file_id, "/MyGroup/Group_a", group, hdferr, & 
                       H5P_DEFAULT_F)

      dims(1)=10
      dims(2)=8
      maxdims(1)=10
      maxdims(2)=8
      call h5screate_simple_f(2, dims, dataspace_id, hdferr, maxdims)
    
      dims_p(1)=4
      dims_p(2)=4
      call h5pcreate_f(H5P_DATASET_CREATE_F, dc_pl, hdferr)
      call h5pset_chunk_f(dc_pl, 2, dims_p, hdferr) 

      call h5dcreate_f(group, "my_dset", H5T_NATIVE_INTEGER, & 
                       dataspace_id, &
                       dataset_id, hdferr, dc_pl, H5P_DEFAULT_F, &
                       H5P_DEFAULT_F)
     
      call h5dclose_f(dataset_id, hdferr) 
      call h5sclose_f(dataspace_id, hdferr)
      call h5gclose_f(group, hdferr) 
      call h5fclose_f(file_id, hdferr) 

! step 4 
      call h5fopen_f(file_name, H5F_ACC_RDWR_F, file_id, hdferr, & 
                     H5P_DEFAULT_F)
      call h5dopen_f(file_id, "/MyGroup/Group_a/my_dset", dataset_id, &
                     hdferr, H5P_DEFAULT_F)

      do i=1,5
        do j=1,4 
           buf(i,j)=1
        enddo
      enddo
      do i=6,10
        do j=1,4 
           buf(i,j)=3
        enddo
      enddo
      do i=1,5
        do j=5,8 
           buf(i,j)=2
        enddo
      enddo
      do i=6,10
        do j=5,8 
           buf(i,j)=4
        enddo
      enddo

      call h5dwrite_f(dataset_id, H5T_NATIVE_INTEGER, buf, dims, & 
                    hdferr, H5S_ALL_F, H5S_ALL_F, H5P_DEFAULT_F)

      call h5dclose_f(dataset_id, hdferr) 
      call h5fclose_f(file_id, hdferr) 

! step 5
      call h5fopen_f(file_name, H5F_ACC_RDWR_F, file_id, hdferr, & 
                     H5P_DEFAULT_F)
      call h5dopen_f(file_id, "/MyGroup/Group_a/my_dset", dataset_id, &
                     hdferr, H5P_DEFAULT_F)

      dims(1)=4
      dims(2)=3
      maxdims(1)=4
      maxdims(2)=3
      call h5screate_simple_f(2, dims, memspace_id, hdferr, maxdims)

      start(1)=3
      start(2)=2 
      count(1)=dims(1)
      count(2)=dims(2)
      stride(1)=1 
      stride(2)=1 
      block(1)=1 
      block(2)=1 
   
      call h5dget_space_f(dataset_id, dataspace_id, hdferr)
      call h5sselect_hyperslab_f(dataspace_id, H5S_SELECT_SET_F, start,&
                   count, hdferr, stride, block)

      do i=1,dims(1)
        do j=1,dims(2)
          s_buf(i,j)=9
        enddo
      enddo 

      call h5dwrite_f(dataset_id, H5T_NATIVE_INTEGER, s_buf, dims, & 
                    hdferr, memspace_id, dataspace_id, H5P_DEFAULT_F)
     
      call h5sclose_f(memspace_id,hdferr)
      call h5dclose_f(dataset_id, hdferr) 
      call h5fclose_f(file_id, hdferr) 

! close the fortran interface for hdf5


      call h5close_f(hdferr);

      end program file_example
